#include "lcd.h"
#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>
#include <stdio.h>

#include "uart.h"
#include "dht11.h"

#define LED1 PB5
#define LED2 PC2
#define SW_A PC3

FILE mystdout = FDEV_SETUP_STREAM(uart_putc, NULL, _FDEV_SETUP_WRITE);

void lcd_print_num(uint8_t num) {
 char buffer[5];
 itoa(num, buffer, 10);
 lcd_puts(buffer);
}

int main(void) {
 uint8_t temp, hum;

 DDRB |= (1<<LED1);
 DDRC |= (1<<LED2);

 uart_init();
 stdout = &mystdout;
 printf("DHT11 + LCD init\n");

 lcd_init();
 lcd_bklt(1);
 lcd_command(0x0C); // Display ON, cursor OFF
lcd_clear();
 while (1) {
  if (dht11_read(&temp, &hum) == 0) {
   // ?????? 1  ???????????
   char send[16];
   sprintf(send,"Teplota: %d %C",temp);
   lcd_setCursor(0, 0);
   lcd_puts(send);
   //lcd_print_num(temp);
   lcd_putc(0xDF); // ?????? ""
   lcd_putc('C');

   // ?????? 2  ?????????
   char message[16];
   
   sprintf(message,"Vlhkost: %d %%",hum);
   lcd_setCursor(1, 0);
   lcd_puts(message);
   // lcd_print_num(hum);
   // lcd_putc('%');

   printf("T: %d C, H: %d %%\n", temp, hum);
  } else {
   lcd_setCursor(0, 0);
   lcd_puts("Chyba citania ");
   lcd_setCursor(1, 0);
   lcd_puts(" ");
   printf("Read error: %d\n",dht11_read(&temp, &hum));
  }

  _delay_ms(2000); // DHT11: ??????? 1 ??????? ????? ?????????
 }
}

